/portfolios/{portfolio_gid}
An existing portfolio can be deleted by making a DELETE request on
the URL for that portfolio.
Returns an empty data record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /portfolios/{portfolio_gid}
/portfolios/{portfolio_gid}
Returns the complete portfolio record for a single portfolio.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /portfolios/{portfolio_gid}
/portfolios/{portfolio_gid}
An existing portfolio can be updated by making a PUT request on the URL for
that portfolio. Only the fields provided in the data block will be updated;
any unspecified fields will remain unchanged.
Returns the complete updated portfolio record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The updated fields for the portfolio.
application/json
PortfoliosUpdatePortfolioRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ color | string | optional |
| └ public | boolean | optional |
| └ members | array | optional |
| └ workspace | string | optional |
Successfully updated the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
PUT /portfolios/{portfolio_gid}
/portfolios/{portfolio_gid}/addCustomFieldSetting
Custom fields are associated with portfolios by way of custom field settings. This method creates a setting for the portfolio.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Information about the custom field setting.
application/json
PortfoliosAddCustomFieldSettingRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ custom_field | string | required |
| └ insert_after | string | optional |
| └ is_important | boolean | optional |
| └ insert_before | string | optional |
Successfully added the custom field to the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/addCustomFieldSetting
/portfolios/{portfolio_gid}/addItem
Add an item to a portfolio.
Returns an empty data block.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Information about the item being inserted.
application/json
PortfoliosAddPortfolioItemRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ item | string | required |
| └ insert_after | string | optional |
| └ insert_before | string | optional |
Successfully added the item to the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/addItem
/portfolios/{portfolio_gid}/addMembers
Adds the specified list of users as members of the portfolio.
Returns the updated portfolio record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the members being added.
application/json
PortfoliosAddMembersToPortfolioRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ members | string | required |
Successfully added members to the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/addMembers
/portfolios/{portfolio_gid}/items
Get a list of the items in compact form in a portfolio.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested portfolio’s items.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /portfolios/{portfolio_gid}/items
/portfolios/{portfolio_gid}/removeCustomFieldSetting
Removes a custom field setting from a portfolio.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Information about the custom field setting being removed.
application/json
PortfoliosRemoveCustomFieldSettingRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ custom_field | string | required |
Successfully removed the custom field from the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/removeCustomFieldSetting
/portfolios/{portfolio_gid}/removeItem
Remove an item from a portfolio.
Returns an empty data block.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Information about the item being removed.
application/json
PortfoliosRemoveItemFromPortfolioRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ item | string | required |
Successfully removed the item from the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/removeItem
/portfolios/{portfolio_gid}/removeMembers
Removes the specified list of users from members of the portfolio.
Returns the updated portfolio record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| portfolio_gid | path | optional | string | Globally unique identifier for the portfolio. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the members being removed.
application/json
PortfoliosRemoveMembersFromPortfolioRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ members | string | required |
Successfully removed the members from the portfolio.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /portfolios/{portfolio_gid}/removeMembers
/project_briefs/{project_brief_gid}
Deletes a specific, existing project brief.
Returns an empty data record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_brief_gid | path | optional | string | Globally unique identifier for the project brief. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified project brief.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /project_briefs/{project_brief_gid}
/project_briefs/{project_brief_gid}
Get the full record for a project brief.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_brief_gid | path | optional | string | Globally unique identifier for the project brief. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the record for a project brief.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The request was valid, but the queried object or object mutation specified in the request is above your current premium level.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
You have exceeded one of the enforced rate limits in the API. See the documentation on rate limiting for more information.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
There is an issue between the load balancers and Asana’s API.
Either the upstream service is unavailable to the API, or the API has been intentionally shut off.
This request took too long to complete.
GET /project_briefs/{project_brief_gid}
/project_briefs/{project_brief_gid}
An existing project brief can be updated by making a PUT request on the URL for
that project brief. Only the fields provided in the data block will be updated;
any unspecified fields will remain unchanged.
Returns the complete updated project brief record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_brief_gid | path | optional | string | Globally unique identifier for the project brief. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The updated fields for the project brief.
application/json
ProjectBriefsUpdateBriefRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ html_text | string | optional |
| └ text | string | optional |
Successfully updated the project brief.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
PUT /project_briefs/{project_brief_gid}
/projects/{project_gid}/project_briefs
Creates a new project brief.
Returns the full record of the newly created project brief.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The project brief to create.
application/json
ProjectBriefsCreateNewRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ html_text | string | optional |
| └ text | string | optional |
Successfully created a new project brief.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The request was valid, but the queried object or object mutation specified in the request is above your current premium level.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/project_briefs
/project_memberships/{project_membership_gid}
Returns the complete project record for a single project membership.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_membership_gid | path | optional | string | — |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested project membership.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /project_memberships/{project_membership_gid}
/projects/{project_gid}/project_memberships
Returns the compact project membership records for the project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| user | query | optional | string | A string identifying a user. This can either be the string “me”, an email, or the gid of a user. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested project’s memberships.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects/{project_gid}/project_memberships
/project_statuses/{project_status_gid}
Deprecated: new integrations should prefer the /status_updates/{status_gid} route.
Deletes a specific, existing project status update.
Returns an empty data record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_status_gid | path | optional | string | The project status update to get. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified project status.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /project_statuses/{project_status_gid}
/project_statuses/{project_status_gid}
Deprecated: new integrations should prefer the /status_updates/{status_gid} route.
Returns the complete record for a single status update.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_status_gid | path | optional | string | The project status update to get. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the specified project’s status updates.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /project_statuses/{project_status_gid}
/projects/{project_gid}/project_statuses
Deprecated: new integrations should prefer the /status_updates route.
Returns the compact project status update records for all updates on the project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the specified project’s status updates.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects/{project_gid}/project_statuses
/projects/{project_gid}/project_statuses
Deprecated: new integrations should prefer the /status_updates route.
Creates a new status update on the project.
Returns the full record of the newly created project status update.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The project status to create.
application/json
ProjectStatusesCreateNewStatusUpdateRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ text | string | optional |
| └ color | string | optional |
| └ html_text | string | optional |
Successfully created a new story.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/project_statuses
/project_templates
Returns the compact project template records for all project templates in the given team or workspace.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| workspace | query | optional | string | The workspace to filter results on. |
| team | query | optional | string | The team to filter projects on. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested team’s or workspace’s project templates.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /project_templates
/project_templates/{project_template_gid}
A specific, existing project template can be deleted by making a DELETE request on the URL for that project template.
Returns an empty data record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_template_gid | path | optional | string | Globally unique identifier for the project template. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified project template.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The request was valid, but the queried object or object mutation specified in the request is above your current premium level.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /project_templates/{project_template_gid}
/project_templates/{project_template_gid}
Returns the complete project template record for a single project template.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_template_gid | path | optional | string | Globally unique identifier for the project template. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested project template.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /project_templates/{project_template_gid}
/project_templates/{project_template_gid}/instantiateProject
Creates and returns a job that will asynchronously handle the project instantiation.
To form this request, it is recommended to first make a request to get a project template. Then, from the response, copy the gid from the object in the requested_dates array. This gid should be used in requested_dates to instantiate a project.
Note: The body of this request will differ if your workspace is an organization. To determine if your workspace is an organization, use the is_organization parameter.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_template_gid | path | optional | string | Globally unique identifier for the project template. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Describes the inputs used for instantiating a project, such as the resulting project’s name, which team it should be created in, and values for date variables.
application/json
ProjectTemplatesInstantiateProjectJobRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ name | string | required |
| └ team | string | optional |
| └ public | boolean | optional |
| └ is_strict | boolean | optional |
| └ requested_dates | array | optional |
| └ gid | string | optional |
| └ value | string | optional |
| └ requested_roles | array | optional |
| └ gid | string | optional |
| └ value | string | optional |
Successfully created the job to handle project instantiation.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /project_templates/{project_template_gid}/instantiateProject
/teams/{team_gid}/project_templates
Returns the compact project template records for all project templates in the team.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| team_gid | path | optional | string | Globally unique identifier for the team. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested team’s project templates.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /teams/{team_gid}/project_templates
/projects
Returns the compact project records for some filtered set of projects. Use one or more of the parameters provided to filter the projects returned.
Note: This endpoint may timeout for large domains. Try filtering by team!
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| workspace | query | optional | string | The workspace or organization to filter projects on. |
| team | query | optional | string | The team to filter projects on. |
| archived | query | optional | boolean | Only return projects whose |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved projects.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects
/projects
Create a new project in a workspace or team.
Every project is required to be created in a specific workspace or
organization, and this cannot be changed once set. Note that you can use
the workspace parameter regardless of whether or not it is an
organization.
If the workspace for your project is an organization, you must also
supply a team to share the project with.
Returns the full record of the newly created project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The project to create.
application/json
ProjectsCreateNewProjectRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ color | string | optional |
| └ notes | string | optional |
| └ due_on | string | optional |
| └ public | boolean | optional |
| └ members | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ archived | boolean | optional |
| └ due_date | string | optional |
| └ start_on | string | optional |
| └ created_at | string | optional |
| └ html_notes | string | optional |
| └ modified_at | string | optional |
| └ default_view | string | optional |
| └ current_status | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ text | string | optional |
| └ color | string | optional |
| └ html_text | string | optional |
| └ author | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ created_at | string | optional |
| └ created_by | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ modified_at | string | optional |
| └ privacy_setting | string | optional |
| └ default_access_level | string | optional |
| └ current_status_update | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ resource_subtype | string | optional |
| └ custom_field_settings | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ parent | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ project | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ custom_field | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ type | string | optional |
| └ enabled | boolean | optional |
| └ id_prefix | string | optional |
| └ date_value | object | optional |
| └ enum_value | object | optional |
| └ text_value | string | optional |
| └ enum_options | array | optional |
| └ number_value | number | optional |
| └ display_value | string | optional |
| └ is_formula_field | boolean | optional |
| └ resource_subtype | string | optional |
| └ multi_enum_values | array | optional |
| └ representation_type | string | optional |
| └ format | string | optional |
| └ precision | integer | optional |
| └ description | string | optional |
| └ custom_label | string | optional |
| └ …8 more | object | optional |
| └ is_important | boolean | optional |
| └ …7 more | object | optional |
Successfully retrieved projects.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects
/projects/{project_gid}
A specific, existing project can be deleted by making a DELETE request on
the URL for that project.
Returns an empty data record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /projects/{project_gid}
/projects/{project_gid}
Returns the complete project record for a single project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects/{project_gid}
/projects/{project_gid}
A specific, existing project can be updated by making a PUT request on
the URL for that project. Only the fields provided in the data block
will be updated; any unspecified fields will remain unchanged.
When using this method, it is best to specify only those fields you wish
to change, or else you may overwrite changes made by another user since
you last retrieved the task.
Returns the complete updated project record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The updated fields for the project.
application/json
ProjectsUpdateProjectRecordRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ color | string | optional |
| └ notes | string | optional |
| └ due_on | string | optional |
| └ public | boolean | optional |
| └ members | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ archived | boolean | optional |
| └ due_date | string | optional |
| └ start_on | string | optional |
| └ created_at | string | optional |
| └ html_notes | string | optional |
| └ modified_at | string | optional |
| └ default_view | string | optional |
| └ current_status | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ text | string | optional |
| └ color | string | optional |
| └ html_text | string | optional |
| └ author | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ created_at | string | optional |
| └ created_by | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ modified_at | string | optional |
| └ privacy_setting | string | optional |
| └ default_access_level | string | optional |
| └ current_status_update | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ resource_subtype | string | optional |
| └ custom_field_settings | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ parent | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ project | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ custom_field | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ type | string | optional |
| └ enabled | boolean | optional |
| └ id_prefix | string | optional |
| └ date_value | object | optional |
| └ enum_value | object | optional |
| └ text_value | string | optional |
| └ enum_options | array | optional |
| └ number_value | number | optional |
| └ display_value | string | optional |
| └ is_formula_field | boolean | optional |
| └ resource_subtype | string | optional |
| └ multi_enum_values | array | optional |
| └ representation_type | string | optional |
| └ format | string | optional |
| └ precision | integer | optional |
| └ description | string | optional |
| └ custom_label | string | optional |
| └ …8 more | object | optional |
| └ is_important | boolean | optional |
| └ …6 more | object | optional |
Successfully updated the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
PUT /projects/{project_gid}
/projects/{project_gid}/addCustomFieldSetting
Custom fields are associated with projects by way of custom field settings. This method creates a setting for the project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the custom field setting.
application/json
ProjectsAddCustomFieldSettingRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ custom_field | string | required |
| └ insert_after | string | optional |
| └ is_important | boolean | optional |
| └ insert_before | string | optional |
Successfully added the custom field to the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/addCustomFieldSetting
/projects/{project_gid}/addFollowers
Adds the specified list of users as followers to the project. Followers are a subset of members who have opted in to receive “tasks added” notifications for a project. Therefore, if the users are not already members of the project, they will also become members as a result of this operation.
Returns the updated project record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the followers being added.
application/json
ProjectsAddFollowersToProjectRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ followers | string | required |
Successfully added followers to the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/addFollowers
/projects/{project_gid}/addMembers
Adds the specified list of users as members of the project. Note that a user being added as a member may also be added as a follower as a result of this operation. This is because the user’s default notification settings (i.e., in the “Notifcations” tab of “My Profile Settings”) will override this endpoint’s default behavior of setting “Tasks added” notifications to false.
Returns the updated project record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the members being added.
application/json
ProjectsAddMembersToProjectRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ members | string | required |
Successfully added members to the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/addMembers
/projects/{project_gid}/duplicate
Creates and returns a job that will asynchronously handle the duplication.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Describes the duplicate’s name and the elements that will be duplicated.
application/json
ProjectsDuplicateProjectJobRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ name | string | required |
| └ team | string | optional |
| └ include | string | optional |
| └ schedule_dates | object | optional |
| └ due_on | string | optional |
| └ start_on | string | optional |
| └ should_skip_weekends | boolean | required |
Successfully created the job to handle duplication.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/duplicate
/projects/{project_gid}/removeCustomFieldSetting
Removes a custom field setting from a project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Information about the custom field setting being removed.
application/json
ProjectsRemoveCustomFieldRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ custom_field | string | required |
Successfully removed the custom field from the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/removeCustomFieldSetting
/projects/{project_gid}/removeFollowers
Removes the specified list of users from following the project, this will not affect project membership status.
Returns the updated project record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the followers being removed.
application/json
ProjectsRemoveProjectFollowersRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ followers | string | required |
Successfully removed followers from the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/removeFollowers
/projects/{project_gid}/removeMembers
Removes the specified list of users from members of the project.
Returns the updated project record.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Information about the members being removed.
application/json
ProjectsRemoveMembersFromProjectRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ members | string | required |
Successfully removed the members from the project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/removeMembers
/projects/{project_gid}/saveAsTemplate
Creates and returns a job that will asynchronously handle the project template creation. Note that
while the resulting project template can be accessed with the API, it won’t be visible in the Asana
UI until Project Templates 2.0 is launched in the app. See more in this forum post.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Describes the inputs used for creating a project template, such as the resulting project template’s name, which team it should be created in.
application/json
ProjectsCreateProjectTemplateJobRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ name | string | required |
| └ team | string | optional |
| └ public | boolean | required |
| └ workspace | string | optional |
Successfully created the job to handle project template creation.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/saveAsTemplate
/projects/{project_gid}/task_counts
Get an object that holds task count fields. All fields are excluded by default. You must opt in using opt_fields to get any information from this endpoint.
This endpoint has an additional rate limit and each field counts especially high against our cost limits.
Milestones are just tasks, so they are included in the num_tasks, num_incomplete_tasks, and num_completed_tasks counts.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested project’s task counts.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects/{project_gid}/task_counts
/tasks/{task_gid}/projects
Returns a compact representation of all of the projects the task is in.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| task_gid | path | optional | string | The task to operate on. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the projects for the given task.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /tasks/{task_gid}/projects
/teams/{team_gid}/projects
Returns the compact project records for all projects in the team.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| team_gid | path | optional | string | Globally unique identifier for the team. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| archived | query | optional | boolean | Only return projects whose |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested team’s projects.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /teams/{team_gid}/projects
/teams/{team_gid}/projects
Creates a project shared with the given team.
Returns the full record of the newly created project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| team_gid | path | optional | string | Globally unique identifier for the team. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The new project to create.
application/json
ProjectsCreateProjectForTeamRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ color | string | optional |
| └ notes | string | optional |
| └ due_on | string | optional |
| └ public | boolean | optional |
| └ members | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ archived | boolean | optional |
| └ due_date | string | optional |
| └ start_on | string | optional |
| └ created_at | string | optional |
| └ html_notes | string | optional |
| └ modified_at | string | optional |
| └ default_view | string | optional |
| └ current_status | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ text | string | optional |
| └ color | string | optional |
| └ html_text | string | optional |
| └ author | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ created_at | string | optional |
| └ created_by | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ modified_at | string | optional |
| └ privacy_setting | string | optional |
| └ default_access_level | string | optional |
| └ current_status_update | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ resource_subtype | string | optional |
| └ custom_field_settings | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ parent | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ project | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ custom_field | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ type | string | optional |
| └ enabled | boolean | optional |
| └ id_prefix | string | optional |
| └ date_value | object | optional |
| └ enum_value | object | optional |
| └ text_value | string | optional |
| └ enum_options | array | optional |
| └ number_value | number | optional |
| └ display_value | string | optional |
| └ is_formula_field | boolean | optional |
| └ resource_subtype | string | optional |
| └ multi_enum_values | array | optional |
| └ representation_type | string | optional |
| └ format | string | optional |
| └ precision | integer | optional |
| └ description | string | optional |
| └ custom_label | string | optional |
| └ …8 more | object | optional |
| └ is_important | boolean | optional |
| └ …7 more | object | optional |
Successfully created the specified project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /teams/{team_gid}/projects
/workspaces/{workspace_gid}/projects
Returns the compact project records for all projects in the workspace.
Note: This endpoint may timeout for large domains. Prefer the /teams/{team_gid}/projects endpoint.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| workspace_gid | path | optional | string | Globally unique identifier for the workspace or organization. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| archived | query | optional | boolean | Only return projects whose |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved the requested workspace’s projects.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /workspaces/{workspace_gid}/projects
/workspaces/{workspace_gid}/projects
Creates a project in the workspace.
If the workspace for your project is an organization, you must also
supply a team to share the project with.
Returns the full record of the newly created project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| workspace_gid | path | optional | string | Globally unique identifier for the workspace or organization. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The new project to create.
application/json
ProjectsCreateInWorkspaceRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ color | string | optional |
| └ notes | string | optional |
| └ due_on | string | optional |
| └ public | boolean | optional |
| └ members | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ archived | boolean | optional |
| └ due_date | string | optional |
| └ start_on | string | optional |
| └ created_at | string | optional |
| └ html_notes | string | optional |
| └ modified_at | string | optional |
| └ default_view | string | optional |
| └ current_status | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ text | string | optional |
| └ color | string | optional |
| └ html_text | string | optional |
| └ author | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ created_at | string | optional |
| └ created_by | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ modified_at | string | optional |
| └ privacy_setting | string | optional |
| └ default_access_level | string | optional |
| └ current_status_update | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ title | string | optional |
| └ resource_subtype | string | optional |
| └ custom_field_settings | array | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ parent | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ project | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ custom_field | object | optional |
| └ gid | string | optional |
| └ resource_type | string | optional |
| └ name | string | optional |
| └ type | string | optional |
| └ enabled | boolean | optional |
| └ id_prefix | string | optional |
| └ date_value | object | optional |
| └ enum_value | object | optional |
| └ text_value | string | optional |
| └ enum_options | array | optional |
| └ number_value | number | optional |
| └ display_value | string | optional |
| └ is_formula_field | boolean | optional |
| └ resource_subtype | string | optional |
| └ multi_enum_values | array | optional |
| └ representation_type | string | optional |
| └ format | string | optional |
| └ precision | integer | optional |
| └ description | string | optional |
| └ custom_label | string | optional |
| └ …8 more | object | optional |
| └ is_important | boolean | optional |
| └ …7 more | object | optional |
Successfully created a new project in the specified workspace.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /workspaces/{workspace_gid}/projects
/rule_triggers/{rule_trigger_gid}/run
Trigger a rule which uses an “incoming web request” trigger.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| rule_trigger_gid | path | optional | string | The ID of the incoming web request trigger. This value is a path parameter that is automatically generated for the API endpoint. |
A dictionary of variables accessible from within the rule.
application/json
RulesTriggerRuleRequestRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ resource | string | required |
| └ action_data | object | required |
Successfully triggered a rule.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The request was valid, but the queried object or object mutation specified in the request is above your current premium level.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /rule_triggers/{rule_trigger_gid}/run
/projects/{project_gid}/sections
Returns the compact records for all sections in the specified project.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| limit | query | optional | integer | Results per page. |
| offset | query | optional | string | Offset token. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved sections in project.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
GET /projects/{project_gid}/sections
/projects/{project_gid}/sections
Creates a new section in a project.
Returns the full record of the newly created section.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
The section to create.
application/json
SectionsCreateNewSectionRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ name | string | required |
| └ insert_after | string | optional |
| └ insert_before | string | optional |
Successfully created the specified section.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/sections
/projects/{project_gid}/sections/insert
Move sections relative to each other. One of
before_section or after_section is required.
Sections cannot be moved between projects.
Returns an empty data block.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| project_gid | path | optional | string | Globally unique identifier for the project. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
The section’s move action.
application/json
SectionsMoveOrInsertRequest
| Property | Type | Required |
|---|---|---|
| data | object | optional |
| └ section | string | required |
| └ after_section | string | optional |
| └ before_section | string | optional |
Successfully moved the specified section.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
POST /projects/{project_gid}/sections/insert
/sections/{section_gid}
A specific, existing section can be deleted by making a DELETE request on
the URL for that section.
Note that sections must be empty to be deleted.
The last remaining section cannot be deleted.
Returns an empty data block.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| section_gid | path | optional | string | The globally unique identifier for the section. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
Successfully deleted the specified section.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
A valid authentication token was not provided with the request, so the API could not associate a user with the request.
The authentication and request syntax was valid but the server is refusing to complete the request. This can happen if you try to read or write to objects or properties that the user does not have access to.
Either the request method and path supplied do not specify a known action in the API, or the object specified by the request does not exist.
There was a problem on Asana’s end. In the event of a server error the response body should contain an error phrase. These phrases can be used by Asana support to quickly look up the incident that caused the server error. Some errors are due to server load, and will not supply an error phrase.
DELETE /sections/{section_gid}
/sections/{section_gid}
Returns the complete record for a single section.
| Name | In | Required | Type | Description |
|---|---|---|---|---|
| section_gid | path | optional | string | The globally unique identifier for the section. |
| opt_pretty | query | optional | boolean | Provides “pretty” output. |
| opt_fields | query | optional | array | This endpoint returns a compact resource, which excludes some properties by default. To include those optional properties, set this query parameter to a comma-separated list of the properties you wish to include. |
Successfully retrieved section.
This usually occurs because of a missing or malformed parameter. Check the documentation and the syntax of your request and try again.
[...]
